//+----------------+
//| FXTradePro.mq4 |
//+----------------+                                                         

#property copyright "Bolla 2008"

#include <stdlib.mqh>

//inputs esterni
extern int     magic             = 0;      // magic number
extern int     Start             = 7;      // Start time 
extern int     Stop              = 15;     // Finish time
extern double  TP                = 40;     // target profit
extern int     SL                = 10;     // stop loss
extern bool    MM                = false;  // Toggle Money Management by L.Williams
extern double  risk              = 0.1;    // Risk Factor
extern double  Lots              = 0.01;   // Lot size
extern int     Slippage          = 3;      // slippage
extern int     Safe_Eq           = 100;    // Max % of fall on equity before close all orders

//variabili globali
double InitLots;
double sB=0,sS=0,openb=1,opens=1;
int    n=0,ripL,ripS,j,init=0,LastTicketL=0,LastTicketS=0;
double LotsB=0,LotsS=0;
double LastB=1000,LastS=0; 
double SM[24];

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
  SM[0]=1;
  SM[1]=1;
  SM[2]=2;
  SM[3]=3;
  SM[4]=4;
  SM[5]=6;
  SM[6]=8;
  SM[7]=11;
  SM[8]=15;
  SM[9]=20;
  SM[10]=27;
  SM[11]=36;
  SM[12]=47;
  SM[13]=62;
  SM[14]=80;
  SM[15]=102;
  SM[16]=130;
  SM[17]=165;
  SM[18]=208;
  SM[19]=263;
  SM[20]=331;
  SM[21]=416;
  SM[22]=522;
  SM[23]=655;
  return(0);
  }

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
  return(0);
  }

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
   {
   if(Bars<1)   {Print("bars less than 1");return(0);}
   
   SafeEquity();   // check equity status

   sB=0;
   sS=0;
   
   if (NormalizeDouble(MarketInfo(Symbol(),MODE_LOTSTEP),2)==0.01) int lotsdigit=2; else lotsdigit=1;
   if (MM) InitLots=NormalizeDouble((AccountBalance()*risk)/(MarketInfo(Symbol(),MODE_TICKVALUE)*100),lotsdigit)*SM[0]; else InitLots=Lots*SM[0];
   if (InitLots<Lots*SM[0]) InitLots=Lots*SM[0];
   if (LotsB==0||LotsS==0) {LotsB=InitLots;LotsS=InitLots;}
   
   for(int i=0;i<OrdersTotal();i++) 
      { 
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic)   
        { 
        switch(OrderType())
           {
           case OP_BUY:
              sB=1;
              LastB=OrderOpenPrice();
              if (OrderTicket()!=LastTicketL) 
               {
               LastTicketL=OrderTicket();
               n++;
               LotsS=InitLots*SM[n];
               }
              break;
           case OP_SELL:
              sS=1;
              LastS=OrderOpenPrice();
              if (OrderTicket()!=LastTicketS)
               {
               LastTicketS=OrderTicket();
               n++;
               LotsB=InitLots*SM[n];
               }
              break;
           }
        }    
      }
   
   ripL=1;
   ripS=1;
   if (LotsB>MarketInfo(Symbol(),MODE_MAXLOT))
      {
      ripL=MathCeil(LotsB/MarketInfo(Symbol(),MODE_MAXLOT));
      LotsB=NormalizeDouble(LotsB/ripL,2);
      if (LotsB>MarketInfo(Symbol(),MODE_MAXLOT)) return(0);
      } 
   if (LotsS>MarketInfo(Symbol(),MODE_MAXLOT))
      {
      ripS=MathCeil(LotsS/MarketInfo(Symbol(),MODE_MAXLOT));
      LotsS=NormalizeDouble(LotsS/ripS,2);
      if (LotsS>MarketInfo(Symbol(),MODE_MAXLOT)) return(0);
      }
      
   double spread=(Ask-Bid)/Point;
   
   if ((sB==1)&&(iClose(NULL,0,0)<=(LastB-SL*Point))&&(opens==1))
         {
         for (j=1;j<=ripS;j++)
            {
            closeAllOrders();
            LastB=1000;
            OpenSell();
            opens=0;
            openb=1;
            init=2;
            }
         return(0);
         }

   if ((sS==1)&&(iClose(NULL,0,0)>=(LastS+(SL-spread)*Point))&&(openb==1))
         {
         for (j=1;j<=ripL;j++)
            {
            closeAllOrders();
            LastS=0;
            OpenBuy();
            openb=0;
            opens=1;
            init=2;
            }
         return(0);
         }
      
   if ((sB==1)&&(iClose(NULL,0,0)>=(LastB+TP*Point))) {closeAllOrders();sB=0;init=0;n=0;LotsB=0;LotsS=0;return(0);}
   if ((sS==1)&&(iClose(NULL,0,0)<=(LastS-(TP+spread)*Point))) {closeAllOrders();sS=0;init=1;n=0;LotsB=0;LotsS=0;return(0);} 
   
      
   if (Tradetime(Start,Stop)==1)
   {
   if ((sB==0)&&(init==0))  {OpenBuy();openb=1;opens=1;}
   if ((sS==0)&&(init==1))  {OpenSell();openb=1;opens=1;}
   }
    
  return (0);
}//end start


// - - - - - - FUNZIONI - - - - - - -

void OpenBuy()
   { 
   while (!IsTradeAllowed()){}
   OrderSend(Symbol(),OP_BUY,LotsB,Ask,Slippage,0,0,NULL,magic,0,CLR_NONE);
   }
 
void OpenSell()
   { 
   while (!IsTradeAllowed()){}
   OrderSend(Symbol(),OP_SELL,LotsS,Bid,Slippage,0,0,NULL,magic,0,CLR_NONE); 
   }

void closeAllOrders()
   {
   for(int x=OrdersTotal()-1;x>=0;x--)
      {
      OrderSelect(x,SELECT_BY_POS,MODE_TRADES);
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==magic)
         {
         while (!IsTradeAllowed()){}
         OrderClose(OrderTicket(), OrderLots(),Bid,Slippage,CLR_NONE);
         }
      }
} 

void SafeEquity()
   {
   if (((AccountBalance()-AccountEquity())/AccountBalance())*100>=Safe_Eq)
      {
      for(int x=OrdersTotal()-1;x>=0;x--)
         {
         OrderSelect(x,SELECT_BY_POS,MODE_TRADES);
         if (OrderSymbol()==Symbol() && OrderType()==OP_BUY)
            {
            while (!IsTradeAllowed()){}
            OrderClose(OrderTicket(), OrderLots(),Bid,1,CLR_NONE);
            }
         if (OrderSymbol()==Symbol() && OrderType()==OP_SELL)
            {
            while (!IsTradeAllowed()){}
            OrderClose(OrderTicket(), OrderLots(), Ask,1,CLR_NONE);
            }
         }
      }
}

int Tradetime(int start,int stop)
   {
   int TradingTime=0;
   if (stop<=start)
      {
      if (TimeHour(Time[0])>=(start)||TimeHour(Time[0])<(stop)) TradingTime=1;
      }
   else 
      {
      if (TimeHour(Time[0])>=(start)&&TimeHour(Time[0])<(stop)) TradingTime=1;
      }
   return(TradingTime); 
   }